//+------------------------------------------------------------------+
//|                                                    Indicator Joy |
//|                                        Copyright 2015, Indicator |
//|                                            http://www.EURSEK.com |
//+------------------------------------------------------------------+
//|  * Remember to un-hide the "DrawDown" conditions                 |
//|  * Change MAGIC for every chart                                  |
//|  * Check "pipPoints" assigned correctly or not                   |
//|  * Check the correct balance assigned on account                 |
//|  * Differ from testing-Different Broker, Pro Bid, live spreads and market trend    
extern string TRADE_SETTINGS=".............................................................................................................";
extern int    MAGIC=150428;  //Change MAGIC for every chart 
extern double BalanceUsage=1000.00;
extern double MarginUsage=0.2;
extern double DrawDown=0.01;
extern string TIME_SETTINGS=".............................................................................................................";
extern int    SignalAStartHour=18;
extern int    SignalAEndHour=17;
extern int    RefreshHours=24;
extern string DEBUG_SETTINGS=".............................................................................................................";
extern bool   DeBug=false;
extern string INDICATOR_SOLAR=".............................................................................................................";
extern int    SolarIndex=1;
extern double SolarLimit=9.1;

bool goTrade=true,closeAll=false;
string filename,display;
int i,h,r,slippage,currentTradeTime,errorCode;
double lotMargin,pipPoints,avrgSpread,buyLots,sellLots,lotSize,multiplyFactor,newProfit,Joy1,Joy2;
double totalTrades,maxLots,minLots,accountBalance,totalProfit,totalLoss,accountEquity,exponentBalance,startBalance;

int histroyPOS=OrdersHistoryTotal(),iniSpreads=1,LotPrecision=2,lastTradeTime=0,lastExponentTime=0,openType=-1;
double totalSpreads=0,highestSpr=0.,lowestSpr=1500.,totalCycles=0,highestBalance=0;
string TradeComment="Solar Joy ^.^";

double currentSpread[24]={0.0,};
double avgSpread[24]={0.,};
double highestSpread[24]= {0.,};
double lowestSpread[24] = {0.,};
double rangeSpread[24]={0.,};
int totalTicks[24]={0,};
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void setPipPoint()
  {
   switch(Digits)
     {
      case 1:  pipPoints=1.0;     break;
      case 2:  pipPoints=0.10;    break;
      case 3:  pipPoints=0.010;   break;
      case 4:  pipPoints=0.0010;  break;
      default: pipPoints=0.00010; break;
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit()
  {
   if(AccountBalance()<BalanceUsage)
     {
      goTrade=false;
      Print("The account balance isn't sufficient for trading !");
     }

   startBalance=accountBalance=BalanceUsage;
   lotMargin=MarketInfo(Symbol(),MODE_MARGINREQUIRED);
   maxLots = MarketInfo(Symbol(),MODE_MAXLOT);
   minLots = MarketInfo(Symbol(), MODE_MINLOT);
   setPipPoint();

   return( INIT_SUCCEEDED );
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   Print(__FUNCTION__,"_Uninitalization reason code = ",reason);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void preparePositions()
  {
   totalTrades = 0;
   totalProfit = 0;
   totalLoss=0;
   buyLots=0;
   sellLots = 0;
   openType = -1;

   for(i=histroyPOS; i<OrdersHistoryTotal(); i++)
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==true && OrderMagicNumber()==MAGIC)
        {
         accountBalance+=OrderProfit()+OrderCommission()+OrderSwap();
         histroyPOS=i+1;
         Print("This order POS ",histroyPOS," was closed at ",OrderClosePrice()," as takeprofit.");
         OrderPrint();
        }
   for(i=0; i<OrdersTotal(); i++)
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true && OrderMagicNumber()==MAGIC)
        {
         if(OrderType()==OP_BUY) buyLots=buyLots+OrderLots();
         else if(OrderType()==OP_SELL) sellLots=sellLots+OrderLots();
         double orderProfit=OrderProfit()+OrderCommission()+OrderSwap();
         if(orderProfit>0) totalProfit+=orderProfit;
         else totalLoss+=orderProfit;
         totalTrades++;
        }
   accountEquity=accountBalance+totalProfit+totalLoss;
   if(accountBalance>highestBalance) highestBalance=accountBalance;

   if(accountBalance/highestBalance<=DrawDown && goTrade==true)
     {
      goTrade=false;
      Print("Balance Drawdown is over the limit and stop opening new orders");
     }
   if(accountEquity/accountBalance<=DrawDown && closeAll==false)
     {
      closeAll=true;
      Print("Equity Drawdown is over the limit and closed all orders");
     }

   if(buyLots>sellLots) openType=OP_BUY;
   else if(sellLots>buyLots) openType=OP_SELL;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void lotSize()
  {
   lotSize=(BalanceUsage*MarginUsage/lotMargin);
   double  lotStep=MarketInfo(Symbol(),MODE_LOTSTEP);
   lotSize=MathRound(lotSize/lotStep)*lotStep;
   if(lotSize>maxLots)      lotSize=maxLots;
   if(lotSize<minLots)      lotSize=minLots;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SolarJoy()
  {
   HideTestIndicators(false);
   Joy1=iCustom(Symbol(),0,"Solar Joy",SolarIndex,1);
   Joy2=iCustom(Symbol(),0,"Solar Joy",SolarIndex,2);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void prepare()
  {
   preparePositions();
   lotSize();
   SolarJoy();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void openPosition()
  {
   double leftMargin=accountBalance-lotSize*lotMargin;
   int errorC=GetLastError();
   if(totalTrades>0 || leftMargin<=10.00 || errorC==134 || goTrade==false)
     {
      if(DeBug) PrintFormat("\nNot opening new orders as Open Orders-%i, Left Margin-%5.2f, Error-%i, goTrade-%i, goTime-%i !",totalTrades,leftMargin,errorC,goTrade);
      return;
     }

   if((SignalAStartHour<SignalAEndHour && h>=SignalAStartHour && h<=SignalAEndHour) || (SignalAStartHour>SignalAEndHour && (( h<=SignalAEndHour && h>=0) || (h<=23 && h>=SignalAStartHour))))
      if(Joy2<-SolarLimit && Joy1>SolarLimit) // && Ask<MACur-(OpenOffset*pipPoints)+avrgSpread*pipPoints) //Correcting MACur to Ask
        {
         r=OrderSend(Symbol(),OP_BUY,lotSize,Ask,slippage,0,0,TradeComment,MAGIC,0,clrMediumBlue);
         currentTradeTime=TimeCurrent();
         lastTradeTime=currentTradeTime;
         if(!r)
           {
            errorCode=GetLastError();
            Print("OpenBuy Error code=",errorCode);
           }
         else Print("OpenBuy with spread/average: ",currentSpread[h],"/",avrgSpread);
        }
   else if(Joy2>SolarLimit && Joy1<-SolarLimit) // && Bid>MACur+(OpenOffset*pipPoints))
     {
      r=OrderSend(Symbol(),OP_SELL,lotSize,Bid,slippage,0,0,TradeComment,MAGIC,0,clrMediumVioletRed);
      currentTradeTime=TimeCurrent();
      lastTradeTime=currentTradeTime;
      if(!r)
        {
         errorCode=GetLastError();
         Print("OpenSell Error code=",errorCode);
        }
      else Print("OpenSell with spread/average: ",currentSpread[h],"/",avrgSpread);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void closePosition()
  {
   if(totalTrades<=0)      return;

   RefreshRates();
   double orderProfit=0;
   if(openType==OP_BUY && ((Joy2>SolarLimit && Joy1<-SolarLimit) || closeAll==true))
      for(i=OrdersTotal();i>=1; i--)
         if(OrderSelect(i-1,SELECT_BY_POS,MODE_TRADES)==true && OrderMagicNumber()==MAGIC)
           {
            r=OrderClose(OrderTicket(),OrderLots(),Bid,slippage,clrDodgerBlue);
            currentTradeTime=TimeCurrent();
            if(r)
              {
               orderProfit=OrderProfit()+OrderCommission()+OrderSwap();
               newProfit+=orderProfit;
               accountBalance+=orderProfit;
               histroyPOS=OrdersHistoryTotal();
               lastTradeTime=currentTradeTime;
               Print(Bid,"(Bid)-",OrderClosePrice(),"(Close) at the slippage target, ",slippage);
               OrderPrint();
              }
            else
              {
               errorCode=GetLastError();
               Print("CloseBuy Error code=",errorCode);
              }
           }
   if(openType==OP_SELL && ((Joy2<-SolarLimit && Joy1>SolarLimit) || closeAll==true))
      for(i=OrdersTotal();i>=1; i--)
         if(OrderSelect(i-1,SELECT_BY_POS,MODE_TRADES)==true && OrderMagicNumber()==MAGIC)
           {
            r=OrderClose(OrderTicket(),OrderLots(),Ask,slippage,clrDeepPink);
            currentTradeTime=TimeCurrent();
            if(r)
              {
               orderProfit=OrderProfit()+OrderCommission()+OrderSwap();
               newProfit+=orderProfit;
               accountBalance+=orderProfit;
               histroyPOS=OrdersHistoryTotal();
               lastTradeTime=currentTradeTime;
               Print(OrderClosePrice(),"(Close)-",Ask,"(Ask) at the slippage target, ",slippage);
               OrderPrint();
              }
            else
              {
               errorCode=GetLastError();
               Print("CloseSell Error code=",errorCode);
              }
           }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnTick()
  {
   prepare();
   openPosition();
   closePosition();
  }
//+------------------------------------------------------------------+
